Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
Botan::CFB_Decryption Class Referencefinal

`#include <cfb.h>`

Inheritance diagram for Botan::CFB_Decryption:

## Public Member Functions
virtual bool | authenticated () const
| CFB_Decryption (BlockCipher *cipher, size_t feedback_bits)
void | clear () override
size_t | default_nonce_length () const override
void | finish (secure_vector< uint8_t > &final_block, size_t offset=0) override
Key_Length_Specification | key_spec () const override
size_t | minimum_final_size () const override
std::string | name () const override
size_t | output_length (size_t input_length) const override
size_t | process (uint8_t buf[], size_t size) override
virtual std::string | provider () const
void | reset () override
template<typename Alloc >
void | set_key (const std::vector< uint8_t, Alloc > &key)
void | set_key (const SymmetricKey &key)
void | set_key (const uint8_t key[], size_t length)
template<typename Alloc >
void | start (const std::vector< uint8_t, Alloc > &nonce)
void | start (const uint8_t nonce[], size_t nonce_len)
void | start ()
virtual size_t | tag_size () const
void | update (secure_vector< uint8_t > &buffer, size_t offset=0)
size_t | update_granularity () const override
bool | valid_keylength (size_t length) const
bool | valid_nonce_length (size_t n) const override

## Protected Member Functions
const BlockCipher & | cipher () const
size_t | feedback () const
secure_vector< uint8_t > & | keystream_buf ()
secure_vector< uint8_t > & | shift_register ()

## Detailed Description

CFB Decryption

Definition at line 84 of file cfb.h.

## Constructor & Destructor Documentation

Botan::CFB_Decryption::CFB_Decryption | ( | BlockCipher * | cipher,
|  | size_t | feedback_bits
| ) |  |
| inline

If feedback_bits is zero, cipher->block_size() bytes will be used.

Parameters

  cipher | block cipher to use
  feedback_bits | number of bits fed back into the shift register, must be a multiple of 8

Definition at line 93 of file cfb.h.

93 :
94 CFB_Mode(cipher, feedback_bits) {}
Botan::CFB_Mode::cipher
const BlockCipher & cipher() const
Definition: cfb.h:43
Botan::CFB_Mode::CFB_Mode
CFB_Mode(BlockCipher *cipher, size_t feedback_bits)
Definition: cfb.cpp:14

## Member Function Documentation

virtual bool Botan::Cipher_Mode::authenticated | ( |  | ) | const
| inline virtual inherited

Returns
  true iff this mode provides authentication as well as confidentiality.

Reimplemented in Botan::AEAD_Mode.

Definition at line 145 of file cipher_mode.h.

145 { return false; }

const BlockCipher& Botan::CFB_Mode::cipher | ( |  | ) | const
| inline protected inherited

Definition at line 43 of file cfb.h.

Referenced by Botan::CFB_Mode::default_nonce_length(), Botan::CFB_Mode::key_spec(), Botan::CFB_Mode::name(), Botan::CFB_Encryption::process(), process(), and Botan::CFB_Mode::valid_nonce_length().

43 { return *m_cipher; }

void Botan::CFB_Mode::clear | ( |  | ) |
| override virtual inherited

Zeroise all state See also reset_msg()

Implements Botan::Cipher_Mode.

Definition at line 23 of file cfb.cpp.

References Botan::CFB_Mode::reset().

24 {
25 m_cipher->clear();
26 reset();
27 }
Botan::CFB_Mode::reset
void reset() override
Definition: cfb.cpp:29

size_t Botan::CFB_Mode::default_nonce_length | ( |  | ) | const
| override virtual inherited

Returns
  the default size for a nonce

Implements Botan::Cipher_Mode.

Definition at line 63 of file cfb.cpp.

References Botan::BlockCipher::block_size(), and Botan::CFB_Mode::cipher().

64 {
65 return cipher().block_size();
66 }
Botan::CFB_Mode::cipher
const BlockCipher & cipher() const
Definition: cfb.h:43
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

size_t Botan::CFB_Mode::feedback | ( |  | ) | const
| inline protected inherited

Definition at line 45 of file cfb.h.

Referenced by Botan::CFB_Mode::CFB_Mode(), Botan::CFB_Mode::name(), Botan::CFB_Encryption::process(), process(), and Botan::CFB_Mode::update_granularity().

45 { return m_feedback_bytes; }

void Botan::CFB_Decryption::finish | ( | secure_vector< uint8_t > & | final_block,
|  | size_t | offset = `0`
| ) |  |
| override virtual

Complete processing of a message.

Parameters

  final_block | in/out parameter which must be at least minimum_final_size() bytes, and will be set to any final output
  offset | an offset into final_block to begin processing

Implements Botan::Cipher_Mode.

Definition at line 151 of file cfb.cpp.

References Botan::Cipher_Mode::update().

152 {
153 update(buffer, offset);
154 }
Botan::Cipher_Mode::update
void update(secure_vector< uint8_t > &buffer, size_t offset=0)
Definition: cipher_mode.h:81

Key_Length_Specification Botan::CFB_Mode::key_spec | ( |  | ) | const
| override virtual inherited

Returns
  object describing limits on key size

Implements Botan::Cipher_Mode.

Definition at line 58 of file cfb.cpp.

References Botan::CFB_Mode::cipher(), and Botan::SymmetricAlgorithm::key_spec().

59 {
60 return cipher().key_spec();
61 }
Botan::CFB_Mode::cipher
const BlockCipher & cipher() const
Definition: cfb.h:43
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

secure_vector<uint8_t>& Botan::CFB_Mode::keystream_buf | ( |  | ) |
| inline protected inherited

Definition at line 49 of file cfb.h.

Referenced by Botan::CFB_Encryption::process(), and process().

49 { return m_keystream_buf; }

size_t Botan::CFB_Mode::minimum_final_size | ( |  | ) | const
| override virtual inherited

Returns
  required minimium size to finalize() - may be any length larger than this.

Implements Botan::Cipher_Mode.

Definition at line 53 of file cfb.cpp.

54 {
55 return 0;
56 }

std::string Botan::CFB_Mode::name | ( |  | ) | const
| override virtual inherited

Implements Botan::Cipher_Mode.

Definition at line 35 of file cfb.cpp.

References Botan::CFB_Mode::cipher(), Botan::CFB_Mode::feedback(), Botan::SymmetricAlgorithm::name(), and Botan::ASN1::to_string().

Referenced by Botan::CFB_Mode::CFB_Mode().

36 {
37 if(feedback() == cipher().block_size())
38 return cipher().name() + "/CFB";
39 else
40 return cipher().name() + "/CFB(" + std::to_string(feedback()*8) + ")";
41 }
Botan::CFB_Mode::cipher
const BlockCipher & cipher() const
Definition: cfb.h:43
Botan::ASN1::to_string
std::string to_string(const BER_Object &obj)
Definition: asn1_obj.cpp:47
Botan::SymmetricAlgorithm::name
virtual std::string name() const =0
Botan::CFB_Mode::feedback
size_t feedback() const
Definition: cfb.h:45

size_t Botan::CFB_Mode::output_length | ( | size_t | input_length | ) | const
| override virtual inherited

Returns the size of the output if this transform is used to process a message with input_length bytes. Will throw if unable to give a precise answer.

Implements Botan::Cipher_Mode.

Definition at line 43 of file cfb.cpp.

44 {
45 return input_length;
46 }

size_t Botan::CFB_Decryption::process | ( | uint8_t | msg[],
|  | size_t | msg_len
| ) |  |
| override virtual

Process message blocks

Input must be a multiple of update_granularity

Processes msg in place and returns bytes written. Normally this will be either msg_len (indicating the entire message was processed) or for certain AEAD modes zero (indicating that the mode requires the entire message be processed in one pass).

Parameters

  msg | the message to be processed
  msg_len | length of the message in bytes

Implements Botan::Cipher_Mode.

Definition at line 120 of file cfb.cpp.

References Botan::BlockCipher::block_size(), Botan::CFB_Mode::cipher(), Botan::copy_mem(), Botan::BlockCipher::encrypt(), Botan::CFB_Mode::feedback(), Botan::CFB_Mode::keystream_buf(), Botan::CT::min(), Botan::CFB_Mode::shift_register(), and Botan::xor_buf().

121 {
122 const size_t BS = cipher().block_size();
123
124 secure_vector<uint8_t>& state = shift_register();
125 const size_t shift = feedback();
126 size_t left = sz;
127
128 while(left)
129 {
130 const size_t took = std::min(shift, left);
131
132 // first update shift register with ciphertext
133 if (BS - shift > 0)
134 {
135 copy_mem(state.data(), &state[shift], BS - shift);
136 }
137 copy_mem(&state[BS-shift], buf, took);
138
139 // then decrypt
140 xor_buf(buf, &keystream_buf()[0], took);
141
142 // then update keystream
143 cipher().encrypt(state, keystream_buf());
144
145 buf += took;
146 left -= took;
147 }
148 return sz;
149 }
Botan::xor_buf
void xor_buf(T out[], const T in[], size_t length)
Definition: mem_ops.h:115
Botan::BlockCipher::encrypt
void encrypt(const uint8_t in[], uint8_t out[]) const
Definition: block_cipher.h:80
Botan::CFB_Mode::cipher
const BlockCipher & cipher() const
Definition: cfb.h:43
Botan::CFB_Mode::shift_register
secure_vector< uint8_t > & shift_register()
Definition: cfb.h:47
Botan::copy_mem
void copy_mem(T *out, const T *in, size_t n)
Definition: mem_ops.h:68
Botan::CFB_Mode::feedback
size_t feedback() const
Definition: cfb.h:45
Botan::CT::min
T min(T a, T b)
Definition: ct_utils.h:180
Botan::CFB_Mode::keystream_buf
secure_vector< uint8_t > & keystream_buf()
Definition: cfb.h:49
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

virtual std::string Botan::Cipher_Mode::provider | ( |  | ) | const
| inline virtual inherited

Returns
  provider information about this implementation. Default is "base", might also return "sse2", "avx2", "openssl", or some other arbitrary string.

Reimplemented in Botan::GCM_Mode.

Definition at line 202 of file cipher_mode.h.

202 { return "base"; }

void Botan::CFB_Mode::reset | ( |  | ) |
| override virtual inherited

Resets just the message specific state and allows encrypting again under the existing key

Implements Botan::Cipher_Mode.

Definition at line 29 of file cfb.cpp.

Referenced by Botan::CFB_Mode::clear().

30 {
31 m_shift_register.clear();
32 m_keystream_buf.clear();
33 }
template<typename Alloc >

void Botan::Cipher_Mode::set_key | ( | const std::vector< uint8_t, Alloc > & | key | ) |
| inline inherited

Set the symmetric key of this transform

Parameters

  key | contains the key material

Definition at line 172 of file cipher_mode.h.

Referenced by botan_cipher_set_key().

173 {
174 set_key(key.data(), key.size());
175 }
Botan::Cipher_Mode::set_key
void set_key(const std::vector< uint8_t, Alloc > &key)
Definition: cipher_mode.h:172

void Botan::Cipher_Mode::set_key | ( | const SymmetricKey & | key | ) |
| inline inherited

Set the symmetric key of this transform

Parameters

  key | contains the key material

Definition at line 181 of file cipher_mode.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

182 {
183 set_key(key.begin(), key.length());
184 }
Botan::Cipher_Mode::set_key
void set_key(const std::vector< uint8_t, Alloc > &key)
Definition: cipher_mode.h:172

void Botan::Cipher_Mode::set_key | ( | const uint8_t | key[],
|  | size_t | length
| ) |  |
| inline inherited

Set the symmetric key of this transform

Parameters

  key | contains the key material
  length | in bytes of key param

Definition at line 191 of file cipher_mode.h.

192 {
193 if(!valid_keylength(length))
194 throw Invalid_Key_Length(name(), length);
195 key_schedule(key, length);
196 }
Botan::Cipher_Mode::name
virtual std::string name() const =0
Botan::Cipher_Mode::valid_keylength
bool valid_keylength(size_t length) const
Definition: cipher_mode.h:162

secure_vector<uint8_t>& Botan::CFB_Mode::shift_register | ( |  | ) |
| inline protected inherited

Definition at line 47 of file cfb.h.

Referenced by Botan::CFB_Encryption::process(), and process().

47 { return m_shift_register; }
template<typename Alloc >

void Botan::Cipher_Mode::start | ( | const std::vector< uint8_t, Alloc > & | nonce | ) |
| inline inherited

Begin processing a message.

Parameters

  nonce | the per message nonce

Definition at line 38 of file cipher_mode.h.

Referenced by botan_cipher_start(), and Botan::TLS::write_record().

39 {
40 start_msg(nonce.data(), nonce.size());
41 }
Botan::Cipher_Mode::start_msg
virtual void start_msg(const uint8_t nonce[], size_t nonce_len)=0

void Botan::Cipher_Mode::start | ( | const uint8_t | nonce[],
|  | size_t | nonce_len
| ) |  |
| inline inherited

Begin processing a message.

Parameters

  nonce | the per message nonce
  nonce_len | length of nonce

Definition at line 48 of file cipher_mode.h.

49 {
50 start_msg(nonce, nonce_len);
51 }
Botan::Cipher_Mode::start_msg
virtual void start_msg(const uint8_t nonce[], size_t nonce_len)=0

void Botan::Cipher_Mode::start | ( |  | ) |
| inline inherited

Begin processing a message.

Definition at line 56 of file cipher_mode.h.

57 {
58 return start_msg(nullptr, 0);
59 }
Botan::Cipher_Mode::start_msg
virtual void start_msg(const uint8_t nonce[], size_t nonce_len)=0

virtual size_t Botan::Cipher_Mode::tag_size | ( |  | ) | const
| inline virtual inherited

Returns
  the size of the authentication tag used (in bytes)

Reimplemented in Botan::SIV_Mode, Botan::CCM_Mode, Botan::OCB_Mode, Botan::TLS::TLS_CBC_HMAC_AEAD_Mode, Botan::ChaCha20Poly1305_Mode, Botan::GCM_Mode, and Botan::EAX_Mode.

Definition at line 150 of file cipher_mode.h.

Referenced by botan_cipher_get_tag_length().

150 { return 0; }

void Botan::Cipher_Mode::update | ( | secure_vector< uint8_t > & | buffer,
|  | size_t | offset = `0`
| ) |  |
| inline inherited

Process some data. Input must be in size update_granularity() uint8_t blocks.

Parameters

  buffer | in/out parameter which will possibly be resized
  offset | an offset into blocks to begin processing

Definition at line 81 of file cipher_mode.h.

References BOTAN_ASSERT.

Referenced by botan_cipher_update(), Botan::XTS_Encryption::finish(), Botan::ChaCha20Poly1305_Encryption::finish(), Botan::CBC_Encryption::finish(), Botan::CFB_Encryption::finish(), Botan::EAX_Encryption::finish(), Botan::XTS_Decryption::finish(), finish(), Botan::CTS_Encryption::finish(), Botan::CBC_Decryption::finish(), Botan::TLS::TLS_CBC_HMAC_AEAD_Encryption::finish(), Botan::CTS_Decryption::finish(), and Botan::TLS::TLS_CBC_HMAC_AEAD_Decryption::finish().

82 {
83 BOTAN_ASSERT(buffer.size() >= offset, "Offset ok");
84 uint8_t* buf = buffer.data() + offset;
85 const size_t buf_size = buffer.size() - offset;
86
87 const size_t written = process(buf, buf_size);
88 buffer.resize(offset + written);
89 }
BOTAN_ASSERT
#define BOTAN_ASSERT(expr, assertion_made)
Definition: assert.h:27
Botan::Cipher_Mode::process
virtual size_t process(uint8_t msg[], size_t msg_len)=0

size_t Botan::CFB_Mode::update_granularity | ( |  | ) | const
| override virtual inherited

Returns
  size of required blocks to update

Implements Botan::Cipher_Mode.

Definition at line 48 of file cfb.cpp.

References Botan::CFB_Mode::feedback().

49 {
50 return feedback();
51 }
Botan::CFB_Mode::feedback
size_t feedback() const
Definition: cfb.h:45

bool Botan::Cipher_Mode::valid_keylength | ( | size_t | length | ) | const
| inline inherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 162 of file cipher_mode.h.

163 {
164 return key_spec().valid_keylength(length);
165 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::Cipher_Mode::key_spec
virtual Key_Length_Specification key_spec() const =0

bool Botan::CFB_Mode::valid_nonce_length | ( | size_t | nonce_len | ) | const
| override virtual inherited

Returns
  true iff nonce_len is a valid length for the nonce

Implements Botan::Cipher_Mode.

Definition at line 68 of file cfb.cpp.

References Botan::CFB_Mode::cipher().

69 {
70 return (n == cipher().block_size());
71 }
Botan::CFB_Mode::cipher
const BlockCipher & cipher() const
Definition: cfb.h:43

The documentation for this class was generated from the following files:

- src/lib/modes/cfb/cfb.h
- src/lib/modes/cfb/cfb.cpp